//+------------------------------------------------------------------+
//|                                              JCC - ATR + JMA.mq4 |
//|                                         Juan Carlos Christensen. |
//|                                     http://www.eumefinancial.com |
//+------------------------------------------------------------------+
#property copyright "Juan Carlos Christensen."
#property link      "http://www.eumefinancial.com"

//#property indicator_chart_window
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

extern int Phase = 0;
extern int Length = 20;
//---- buffers
double ATRJMA[];
double Series;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ATRJMA);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int reset,counted_bars=IndicatorCounted();
//----+ check for possible errors
   if (counted_bars<0) return (-1);
   int limit=Bars;//-counted_bars-1;
//----+ introduction and the initialization of the internal variables of function JJMASeries (one turning to function, parameters nJMAPhase and nJMALength they do not change)
   
   if (limit==Bars-1)
   {
      reset=-1;
      
      int set=JJMASeries(0,1,0,0,0,0,0,0,reset);
      
      if((reset==1)||(set!=0))return(-1);
      
      reset=1;
   }
//----+turning to function JJMASeries for calculating the buffer Ind_.Buffer[ 
   for(int x=limit;x>=0;x--)
   {
      reset=1;
      
      Series=iATR(NULL, 0, 1, x);
      
      ATRJMA[x]=JJMASeries(0,0,Bars-1,limit,Phase,Length,Series,x,reset);
      
      if (reset!=0)return(-1);
   }
   
   return(0);
}
//----+ the determination of function JJMASeries
#include <JJMASeries.mqh>